Attribute VB_Name = "MFiber"
'Die einzige(!) Fiber-Klasse im Projekt
Public Fibers As New CFiber

Public Type FiberData
    Fiber As Long
    Id As Long
    UserProc As Long
    UserParam As Long
    LastTimeSlice As Currency
    SleepTimeout As Currency
    DeletionPending As Boolean
End Type

Private Declare Function VirtualAlloc Lib "kernel32.dll" (ByRef lpAddress As Any, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Const MEM_COMMIT As Long = &H1000
Private Const PAGE_EXECUTE_READWRITE As Long = &H40

Private Declare Function CallWindowProc Lib "user32" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hWnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
                         
Private Ptr As Long

'Proxy-Funktion fr Fibers
Public Sub FiberMainProc(ByRef Param As FiberData)

'ASM Proc generieren
If (Ptr = 0) Then

    Dim asm(0 To 19) As Byte
    
    asm(0) = &H50 'push (save) eax
    asm(1) = &H56 'push (save) esi
    asm(2) = &H8B 'mov eax, [esp+&H10] (Param)
    asm(3) = &H44
    asm(4) = &H24
    asm(5) = &H10
    asm(6) = &H8B 'mov esi,[esp+&H0c] (Address)
    asm(7) = &H74
    asm(8) = &H24
    asm(9) = &HC
    asm(10) = &H50 'push eax (Param)
    asm(11) = &HFF 'call esi (Address)
    asm(12) = &HD6
    asm(13) = &H5E 'pop (restore) esi
    asm(14) = &H58 'pop (restore) eax
    asm(15) = &HC2 'ret 16
    asm(16) = &H10
    asm(17) = 0
    
    Ptr = VirtualAlloc(ByVal 0&, 20, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    Call CopyMemory(ByVal Ptr, asm(0), 20)
    
End If

'Kontrolle an eigentliche Funktion delegieren
Call CallWindowProc(Ptr, Param.UserProc, Param.UserParam, 0&, 0&)
 
'Funktion wurde beendet. Dieser Fiber darf mit seiner Beendigung nicht mehr scheduled werden
Call Fibers.DeleteFiber(Fibers.GetCurrentFiber())

'Diese Funktion darf nicht wieder verlassen werden. Da der Fiber sich nicht selbst lschen kann,
'muss so lange fr einen Verbleib in dieser Funktion gesorgt werden, bis der Kontext gewechselt wurde und
'der Fiber gelscht wird
Do
Loop

End Sub
